	subroutine fmmbvector(n,x,y,node,dnorm,bc,u,ax,a,b,xmax,xmin,
     &              ymax,ymin,ielem,itree,level,loct,numt,ifath,
     &              nexp,ntylr,ncellmx,lowlev,maxl,rwork,iwork)

      implicit real*8(a-h,o-z)
      complex*16 a,b

      dimension a(0:nexp,ncellmx),b(0:ntylr,ncellmx),
     &          x(2,*),y(2,*),node(2,*),dnorm(2,*),bc(2,*),u(*),ax(*),
     &          ielem(*),itree(*),level(0:*),loct(*),numt(*),ifath(*),
     &          rwork(*),iwork(*)

c Switch the BC type

	do i=1,n
	  if(bc(1,i) .eq. 1.) then
	    bc(1,i) = 2.d0
	  else
	    bc(1,i) = 1.d0
	  endif
	enddo

      do i=1,n
        u(i)  = bc(2,ielem(i))
        ax(i) = 0.d0
      enddo

c Apply the FMM to conpute the right-hand side vector b

      call upward(u,n,y,node,dnorm,bc,a,xmax,xmin,ymax,ymin,ielem,
     &        itree,level,loct,numt,ifath,nexp,ncellmx,lowlev,maxl)

      call dwnwrd(u,ax,n,x,y,node,dnorm,bc,a,b,xmax,xmin,ymax,ymin,
     &        ielem,itree,level,loct,numt,ifath,nexp,ntylr,ncellmx,
     &        lowlev,maxl,rwork,iwork)

c Store b vector in u and switch the BC type back

	do i=1,n
	  u(i) = - ax(i)
	  if(bc(1,i) .eq. 1.) then
	    bc(1,i) = 2.d0
	  else
	    bc(1,i) = 1.d0
	  endif
	enddo

	return
	end