c-------------------------------------------------------------------------------
	subroutine lpointer(lp, ln, maxia, ia, n, nexp, ntylr, ncellmx,
     &              levmx, ligw, lrgw, nwksz, iwksz, nfield,
     &              l_n,       l_x,       l_y,     l_node,  l_dnorm, 
     &              l_bc,      l_a,       l_b,     l_xmax,  
     &              l_xmin,    l_ymax,    l_ymin,  l_ielem, l_itree, 
     &              l_level,   l_loct,    l_numt,  l_ifath, l_lowlev, 
     &              l_maxl,    l_levmx,   l_nexp,  l_ntylr, l_tolerance,
     &              l_ncellmx, l_nleafmx, l_mxl,   l_u,     l_ax,
     &              l_sb,      l_sx,      l_ligw,  l_lrgw,  l_igwk, 
     &              l_rgwk,    l_nwksz,   l_iwksz, l_rwork, l_iwork, 
     &              l_xfield,  l_nfield,  l_f)

	dimension ia(maxia)

	lp   = 1

	l_n         = l_address( 1,maxia,ia,lp,4,1)
	l_x         = l_address( 2,maxia,ia,lp,8,n*2)
	l_y         = l_address( 3,maxia,ia,lp,8,n*2)
	l_node      = l_address( 4,maxia,ia,lp,4,n*2)
	l_dnorm     = l_address( 5,maxia,ia,lp,8,n*2)
	l_bc        = l_address( 6,maxia,ia,lp,8,n*2)
	l_a         = l_address( 7,maxia,ia,lp,16,(nexp+1)*ncellmx)
	l_b         = l_address( 8,maxia,ia,lp,16,(ntylr+1)*ncellmx)
	l_xmax      = l_address( 9,maxia,ia,lp,8,1)
	l_xmin      = l_address(10,maxia,ia,lp,8,1)
	l_ymax      = l_address(11,maxia,ia,lp,8,1)
	l_ymin      = l_address(12,maxia,ia,lp,8,1)
	l_ielem     = l_address(13,maxia,ia,lp,4,n)
	l_itree     = l_address(14,maxia,ia,lp,4,ncellmx)
	l_level     = l_address(15,maxia,ia,lp,4,levmx+1)
	l_loct      = l_address(16,maxia,ia,lp,4,ncellmx)
	l_numt      = l_address(17,maxia,ia,lp,4,ncellmx)
	l_ifath     = l_address(18,maxia,ia,lp,4,ncellmx)
	l_lowlev    = l_address(19,maxia,ia,lp,4,1)
	l_maxl      = l_address(20,maxia,ia,lp,4,1)
	l_levmx     = l_address(21,maxia,ia,lp,4,1)
	l_nexp      = l_address(22,maxia,ia,lp,4,1)
	l_ntylr     = l_address(23,maxia,ia,lp,4,1)
	l_tolerance = l_address(24,maxia,ia,lp,8,1)
	l_ncellmx   = l_address(25,maxia,ia,lp,4,1)
	l_nleafmx   = l_address(26,maxia,ia,lp,4,1)
	l_mxl       = l_address(27,maxia,ia,lp,4,1)
	l_u         = l_address(28,maxia,ia,lp,8,n)
	l_ax        = l_address(29,maxia,ia,lp,8,n)
	l_sb        = l_address(30,maxia,ia,lp,8,n)
	l_sx        = l_address(31,maxia,ia,lp,8,n)
	l_ligw      = l_address(32,maxia,ia,lp,4,1)
	l_lrgw      = l_address(33,maxia,ia,lp,4,1)
	l_igwk      = l_address(34,maxia,ia,lp,4,ligw)
	l_rgwk      = l_address(35,maxia,ia,lp,8,lrgw)
	l_nwksz     = l_address(36,maxia,ia,lp,4,1)
	l_iwksz     = l_address(37,maxia,ia,lp,4,1)
	l_rwork     = l_address(38,maxia,ia,lp,8,nwksz)
	l_iwork     = l_address(39,maxia,ia,lp,4,iwksz)
	l_xfield    = l_address(40,maxia,ia,lp,8,nfield*2)
	l_nfield    = l_address(41,maxia,ia,lp,4,1)
	l_f         = l_address(42,maxia,ia,lp,8,nfield)

	return
	end

c-------------------------------------------------------------------------------

      integer function l_address(ln,maxia,ia,lp,ibyte,length)

      dimension ia(maxia)

      l_address = lp
      ia(ln)    = lp

	iu  = 16
      inc = (ibyte*length-1)/iu+1
      lp  = lp+inc
      if(ln .gt. maxia) then
        write(*,*)'!Specified # of variables maxia',maxia,'is too small'
	  stop
      endif

      return
      end

c-------------------------------------------------------------------------------

      subroutine assigni(i,ii)

      integer i,ii
      ii = i

      return
      end

      subroutine assignd(d,dd)

      real*8 d,dd
      dd = d

      return
      end

c-------------------------------------------------------------------------------